package com.tzld.piaoquan.recommend.feature.service;

import com.google.common.base.Strings;
import com.tzld.piaoquan.recommend.feature.model.UserActionFeature;
import com.tzld.piaoquan.recommend.feature.model.UserFeature;
import com.tzld.piaoquan.recommend.feature.model.VideoFeature;
import com.tzld.piaoquan.recommend.feature.model.feature.UserActionFeatureProto;
import com.tzld.piaoquan.recommend.feature.model.feature.UserFeatureProto;
import com.tzld.piaoquan.recommend.feature.model.feature.VideoFeatureProto;

/**
 * @author dyp
 */
public class FeatureConverter {
    public static UserFeatureProto convert(UserFeature userFeature) {
        UserFeatureProto.Builder builder = UserFeatureProto.newBuilder();
        builder.setMid(Strings.nullToEmpty(userFeature.getMid()))
                .setUid(Strings.nullToEmpty(userFeature.getUid()))
                .setUserCycleBucket7Day(Strings.nullToEmpty(userFeature.getUserCycleBucket7days()))
                .setUserCycleBucket30Day(Strings.nullToEmpty(userFeature.getUserCycleBucket30days()))
                .setUserShareBucket30Day(Strings.nullToEmpty(userFeature.getUserShareBucket30days()))
                .setDay1CntFeature(convert(userFeature.getDay1CntFeature()))
                .setDay3CntFeature(convert(userFeature.getDay3CntFeature()))
                .setDay7CntFeature(convert(userFeature.getDay7CntFeature()))
                .setMonth3CntFeature(convert(userFeature.getMonth3CntFeature()));
        return builder.build();
    }

    private static UserActionFeatureProto convert(UserActionFeature feature) {
        UserActionFeatureProto.Builder builder = UserActionFeatureProto.newBuilder();
        builder.setCtr(feature.getCtr())
                .setStr(feature.getStr())
                .setRov(feature.getRov())
                .setShareCnt(feature.getShareCnt())
                .setReturnCnt(feature.getReturnCnt())
                .setClickCnt(feature.getClickCnt())
                .setExpCnt(feature.getExpCnt());

        return builder.build();
    }


    public static VideoFeatureProto convert(VideoFeature videoFeature) {
        VideoFeatureProto.Builder builder = VideoFeatureProto.newBuilder();

        builder.setVideoId(Strings.nullToEmpty(videoFeature.getVideoId()))
                .setUpId(Strings.nullToEmpty(videoFeature.getUpId()))
                .setTags(Strings.nullToEmpty(videoFeature.getTags()))
                .setPlayLength(Strings.nullToEmpty(videoFeature.getPlayLength()))
                .setTotalTime(Strings.nullToEmpty(videoFeature.getTotalTime()))
                .setDaysSinceUpload(Strings.nullToEmpty(videoFeature.getDaysSinceUpload()))
                .setVideoDay1CntFeature(convert(videoFeature.getVideoDay1CntFeature()))
                .setVideoDay3CntFeature(convert(videoFeature.getVideoDay3CntFeature()))
                .setVideoDay7CntFeature(convert(videoFeature.getVideoDay7CntFeature()))
                .setVideoMonth3CntFeature(convert(videoFeature.getVideoMonth3CntFeature()));

        // TODO
        return builder.build();
    }
}
